import 'package:flutter/cupertino.dart';
import 'package:forme/forme.dart';

class FormeCupertinoSlidingSegmentedControl<T extends Object>
    extends FormeField<T?> {
  FormeCupertinoSlidingSegmentedControl({
    String? name,
    T? initialValue,
    bool readOnly = false,
    Key? key,
    int? order,
    bool quietlyValidate = false,
    Duration? asyncValidatorDebounce,
    AutovalidateMode? autovalidateMode,
    FormeFieldStatusChanged<T?>? onStatusChanged,
    FormeFieldInitialized<T?>? onInitialized,
    FormeFieldSetter<T?>? onSaved,
    FormeValidator<T?>? validator,
    FormeAsyncValidator<T?>? asyncValidator,
    FormeFieldDecorator<T?>? decorator,
    bool requestFocusOnUserInteraction = true,
    bool enabled = true,
    FormeFieldValidationFilter<T?>? validationFilter,
    FocusNode? focusNode,
    FormeValueComparator<T?>? comparator,
    required this.children,
    this.backgroundColor,
    this.disableBackgroundColor,
    this.disableThumbColor,
    this.padding,
    this.thumbColor,
  }) : super.allFields(
            comparator: comparator,
            focusNode: focusNode,
            validationFilter: validationFilter,
            enabled: enabled,
            requestFocusOnUserInteraction: requestFocusOnUserInteraction,
            decorator: decorator,
            quietlyValidate: quietlyValidate,
            asyncValidatorDebounce: asyncValidatorDebounce,
            autovalidateMode: autovalidateMode,
            onStatusChanged: onStatusChanged,
            onInitialized: onInitialized,
            onSaved: onSaved,
            validator: validator,
            asyncValidator: asyncValidator,
            order: order,
            name: name,
            initialValue: initialValue,
            readOnly: readOnly,
            key: key,
            builder: (state) {
              final bool readOnly = state.readOnly;
              return Focus(
                focusNode: state.focusNode,
                child: IgnorePointer(
                  ignoring: readOnly,
                  child: CupertinoSlidingSegmentedControl<T>(
                      groupValue: state.value,
                      children: children,
                      thumbColor: (readOnly ? disableThumbColor : thumbColor) ??
                          const CupertinoDynamicColor.withBrightness(
                            color: Color(0xFFFFFFFF),
                            darkColor: Color(0xFF636366),
                          ),
                      backgroundColor: (readOnly
                              ? disableBackgroundColor
                              : backgroundColor) ??
                          CupertinoColors.tertiarySystemFill,
                      padding: padding ??
                          const EdgeInsets.symmetric(
                              vertical: 2, horizontal: 3),
                      onValueChanged: (v) {
                        state.didChange(v);
                        state.requestFocusOnUserInteraction();
                      }),
                ),
              );
            });

  final Map<T, Widget> children;
  final Color? thumbColor;
  final Color? backgroundColor;
  final EdgeInsetsGeometry? padding;
  final Color? disableThumbColor;
  final Color? disableBackgroundColor;
}
