import 'package:flutter/cupertino.dart';
import 'package:flutter/gestures.dart';
import 'package:forme/forme.dart';

class FormeCupertinoSwitch extends FormeField<bool> {
  FormeCupertinoSwitch({
    bool initialValue = false,
    String? name,
    bool readOnly = false,
    Key? key,
    int? order,
    bool quietlyValidate = false,
    Duration? asyncValidatorDebounce,
    AutovalidateMode? autovalidateMode,
    FormeFieldStatusChanged<bool>? onStatusChanged,
    FormeFieldInitialized<bool>? onInitialized,
    FormeFieldSetter<bool>? onSaved,
    FormeValidator<bool>? validator,
    FormeAsyncValidator<bool>? asyncValidator,
    FormeFieldDecorator<bool>? decorator,
    bool requestFocusOnUserInteraction = true,
    bool enabled = true,
    FormeFieldValidationFilter<bool>? validationFilter,
    FocusNode? focusNode,
    this.activeColor,
    this.dragStartBehavior = DragStartBehavior.start,
    this.thumbColor,
    this.trackColor,
  }) : super.allFields(
          comparator: null,
          focusNode: focusNode,
          validationFilter: validationFilter,
          enabled: enabled,
          requestFocusOnUserInteraction: requestFocusOnUserInteraction,
          quietlyValidate: quietlyValidate,
          asyncValidatorDebounce: asyncValidatorDebounce,
          autovalidateMode: autovalidateMode,
          onStatusChanged: onStatusChanged,
          onInitialized: onInitialized,
          onSaved: onSaved,
          validator: validator,
          asyncValidator: asyncValidator,
          order: order,
          key: key,
          decorator: decorator,
          readOnly: readOnly,
          name: name,
          initialValue: initialValue,
          builder: (state) {
            final bool readOnly = state.readOnly;
            final bool value = state.value;
            return CupertinoSwitch(
              thumbColor: thumbColor,
              value: value,
              onChanged: readOnly
                  ? null
                  : (v) {
                      state.didChange(v);
                      state.requestFocusOnUserInteraction();
                    },
              activeColor: activeColor,
              trackColor: trackColor,
              dragStartBehavior: dragStartBehavior,
            );
          },
        );

  final Color? activeColor;
  final Color? trackColor;
  final DragStartBehavior dragStartBehavior;
  final Color? thumbColor;
}
